Public Class Form1
    Private Values1d() As String
    Private Values2d(,) As String

    ' Initialize the values.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ReDim Values1d(4)
        For col As Integer = 0 To Values1d.GetUpperBound(0)
            Values1d(col) = "(" & col.ToString() & ")"
        Next col

        ReDim Values2d(4, 3)
        For row As Integer = 0 To Values2d.GetUpperBound(0)
            For col As Integer = 0 To Values2d.GetUpperBound(1)
                Values2d(row, col) = "(" & row.ToString() & ", " & col.ToString() & ")"
            Next col
        Next row

        ' Display the values.
        ShowValues(lstValues1d, Values1d)
        ShowValues(lstValues2d, Values2d)
    End Sub

    ' Copy the values.
    Private Sub btnCopy1d_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCopy1d.Click
        ' Copy the array.
        Dim new_values() As String = Values1d.SubArray(1, 3)

        ' Display the values.
        ShowValues(lstCopy1d, new_values)
    End Sub

    ' Copy the values.
    Private Sub btnCopy2d_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCopy2d.Click
        ' Copy the array.
        Dim new_values(,) As String = Values2d.SubArray(2, 3, 1, 3)

        ' Display the values.
        ShowValues(lstCopy2d, new_values)
    End Sub

    ' Display some values in a ListBox.
    Private Sub ShowValues(ByVal lst As ListBox, ByVal the_values(,) As String)
        lst.Items.Clear()
        For row As Integer = 0 To the_values.GetUpperBound(0)
            Dim str As String = ""
            For col As Integer = 0 To the_values.GetUpperBound(1)
                str &= the_values(row, col) & " "
            Next col
            str = str.Substring(0, str.Length - 1)
            lst.Items.Add(str)
        Next row
    End Sub

    Private Sub ShowValues(ByVal lst As ListBox, ByVal the_values() As String)
        lst.Items.Clear()
        Dim str As String = ""
        For col As Integer = 0 To the_values.GetUpperBound(0)
            str &= the_values(col) & " "
        Next col
        str = str.Substring(0, str.Length - 1)
        lst.Items.Add(str)
    End Sub
End Class
